/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: nios2_mpu.h 7638 2013-06-27 05:20:41Z fsi-dankei $
 */

/*
 *		Nios2 MPUϢ
 */

#ifndef TOPPERS_NIOS2_MPU_H
#define TOPPERS_NIOS2_MPU_H

/*
 *  Nios2 MPU ꡼󥵥(Byte)
 */
#define NIOS2_MPU_REGION_SIZE	64

/*
 *  Nios2 MPU config 쥸
 */

#define NIOS2_MPU_DISABLE	UINT_C(0x000000000)
#define NIOS2_MPU_ENABLE	UINT_C(0x000000001)

/*
 *  Nios2 MPU  ӥåȥѥ
 */
#define NIOS2_MPU_PERM_SYS_NEX_USR_NEX	UINT_C(0x00000000)
#define NIOS2_MPU_PERM_SYS_EXC_USR_NEX	UINT_C(0x00000001)
#define NIOS2_MPU_PERM_SYS_EXC_USR_EXC	UINT_C(0x00000002)

#define NIOS2_MPU_PERM_SYS_NO_USR_NO	UINT_C(0x00000000)
#define NIOS2_MPU_PERM_SYS_RO_USR_NO	UINT_C(0x00000001)
#define NIOS2_MPU_PERM_SYS_RO_USR_RO	UINT_C(0x00000002)
#define NIOS2_MPU_PERM_SYS_RW_USR_NO	UINT_C(0x00000004)
#define NIOS2_MPU_PERM_SYS_RW_USR_RO	UINT_C(0x00000005)
#define NIOS2_MPU_PERM_SYS_RW_USR_RW	UINT_C(0x00000006)

#define NIOS2_MPU_INDEX_SHIFT			1
#define NIOS2_MPU_PERM_SHIFT			2
#define NIOS2_MPU_DATA_REGION			UINT_C(1)
#define NIOS2_MPU_WRITE					UINT_C(1)
#define NIOS2_MPU_READ					UINT_C(2)
#define NIOS2_MPU_CACHEABLE				UINT_C(1)
#define NIOS2_MPU_CACHEABLE_SHIFT		5

/*
 *  MPU쥸 mpubase͹ޥ
 */
#define NIOS2_INST_MPUBASE(index, address)	((((uint32) (address)) & (0x7fffffc0U)) | ((((uint32) (index)) & (NIOS2_MPU_INST_MAX_NUM - (1U))) << NIOS2_MPU_INDEX_SHIFT))
#define NIOS2_DATA_MPUBASE(index, address)	((((uint32) (address)) & (0x7fffffc0U)) | ((((uint32) (index)) & (NIOS2_MPU_DATA_MAX_NUM - (1U))) << NIOS2_MPU_INDEX_SHIFT) | NIOS2_MPU_DATA_REGION)

/*
 *  MPU쥸 mpuacc͹ޥ
 */
#define NIOS2_MPUACC(perm, address)			(((uint32) (address) & (0xffffffc0U)) | ((uint32) (perm) << NIOS2_MPU_PERM_SHIFT) | NIOS2_MPU_WRITE)
#ifdef NIOS2_USE_DATACACHE
#define NIOS2_MPUACC_DATA(perm, address)	(((uint32) (address) & (0xffffffc0U)) | ((uint32) NIOS2_MPU_CACHEABLE << NIOS2_MPU_CACHEABLE_SHIFT) | (((uint32) (perm)) << NIOS2_MPU_PERM_SHIFT) | NIOS2_MPU_WRITE)
#else
#define NIOS2_MPUACC_DATA(perm, address)	(((uint32) (address) & (0xffffffc0U)) | ((uint32) (perm) << NIOS2_MPU_PERM_SHIFT) | NIOS2_MPU_WRITE)
#endif /* NIOS2_USE_DATACACHE */

/*
 *  MPU index  ΰޥ
 */

/* Instruction MPU */
#define NIOS2_MPU_BKGND_CODE_REGION			((NIOS2_MPU_INST_MAX_NUM) - (1U))

/* Data MPU */
/*
 *  եå롼ϥƱưʤᡤ
 *  եå롼󥹥åȥåƱMPUȤ
 */
#define NIOS2_MPU_STACK_REGION					UINT_C(0)
#define NIOS2_MPU_PRV_DATA_REGION_START			UINT_C(1)

#define NIOS2_MPU_BKGND_DATA_REGION				((NIOS2_MPU_DATA_MAX_NUM) - (1U))

#ifndef TOPPERS_MACRO_ONLY


/*
 *  Nios2 MPU֥å
 *    MPUͤ¸
 *       MPUͤMPU˻Ѥ
 */
typedef struct mpu_contex_block {
	uint32	mpubase;    /* mpubase쥸 */
	uint32	mpuacc;     /* mpuacc쥸 */
} MPUINFOB;

typedef	MPUINFOB STKMPUINFOB;

/*
 *  OSץꥱ֥å˻OSץꥱMPU
 *     OSץꥱ˸ͭ
 *     ¹Իѹ뤳Ȥ̵
 */

typedef struct osap_mpuinfob {
	const MPUINFOB	*p_mpu_region;
	uint8			tnum_inst_region;
	uint8			tnum_data_region;
} OSAPMPUINFOB;


/*
 *  ͭΰ  Τkernel_mem.c 
 */
extern const MPUINFOB	shared_region[];
extern const uint8		tnum_shared_region;

extern void prc_set_osap_mpu(const OSAPINIB *p_osapinib);

/*
 *  MPU ޥ
 */

LOCAL_INLINE void
mpu_enable(void)
{
	uint32 enable = NIOS2_MPU_ENABLE;
	Asm("wrctl config, %0" :: "r" (enable));
}

LOCAL_INLINE void
mpu_disable(void)
{
	Asm("wrctl config, zero");
}

LOCAL_INLINE void
mpu_set_mpubase(uint32 data)
{
	Asm("wrctl mpubase, %0" :: "r" (data));
}

LOCAL_INLINE void
mpu_set_mpuacc(uint32 data)
{
	Asm("wrctl mpuacc, %0" :: "r" (data));
}

/*
 *  MPUξ
 */
LOCAL_INLINE void
prc_set_mpu(const MPUINFOB *mpuinfo)
{
	mpu_set_mpubase(mpuinfo->mpubase);
	mpu_set_mpuacc(mpuinfo->mpuacc);
}

/*
 *  MPU
 */
extern void prc_init_mpu(void);

/*
 *  MPU¸å
 */
extern AccessType probe_trusted_osap_mem(const MemoryStartAddressType sadr, const MemoryStartAddressType eadr);

#endif /* TOPPERS_MACRO_ONLY */


#endif /* TOPPERS_NIOS2_MPU_H */
