/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: uart.h 7327 2013-04-05 06:53:27Z shigihara $
 */

/*
 *		ꥢI/OǥХSIO˥ɥ饤СUARTѡ
 */

#ifndef TOPPERS_UART_H
#define TOPPERS_UART_H

#include "prc_sil.h"
#include "nios2.h"

/*
 *  ϡɥ
 */
/*
 *  쥸եå
 */
#define UART_RXDATA_OFFSET	UINT_C(0x00)
#define UART_TXDATA_OFFSET	UINT_C(0x04)
#define UART_STATUS_OFFSET	UINT_C(0x08)
#define UART_CONTROL_OFFSET	UINT_C(0x0c)
#define UART_DIVISOR_OFFSET	UINT_C(0x10)

/*
 *  쥸ӥå
 */
#define UART_STATUS_TRDY	UINT_C(0x0040)
#define UART_STATUS_RRDY	UINT_C(0x0080)
#define UART_CONTROL_IRRDY	UINT_C(0x0080)


#ifndef TOPPERS_MACRO_ONLY

extern const uint32	target_fput_log_base_table[];

/*
 *  ͥ٥Ѵؿ(UART)
 */

LOCAL_INLINE void
nios2_dev_putc(char8 c)
{
	uint32 base = target_fput_log_base_table[x_core_id()];

	while ((sil_rew_iop((void *) (base + UART_STATUS_OFFSET)) & UART_STATUS_TRDY) == 0U) {
	}
	sil_wrw_iop((void *) (base + UART_TXDATA_OFFSET), (uint32) c);
}

/*
 *  serial.c ƤӽФؿ
 */

/*
 *  
 */
extern void InitHwSerial(void);

/*
 *  λ
 */
extern void TermHwSerial(void);

/*
 *  Хåϥɥ
 */
extern void RxSerialInt(uint8 character);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_UART_H */
