/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: interrupt_manage.c 7596 2013-06-21 06:42:41Z whirahashi $
 */

/*
 *		ߴ⥸塼
 */

#include "kernel_impl.h"
#include "check.h"
#include "interrupt.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_DISINT_ENTER
#define LOG_DISINT_ENTER()
#endif /* LOG_DISINT_ENTER */

#ifndef LOG_DISINT_LEAVE
#define LOG_DISINT_LEAVE()
#endif /* LOG_DISINT_LEAVE */

#ifndef LOG_ENAINT_ENTER
#define LOG_ENAINT_ENTER()
#endif /* LOG_ENAINT_ENTER */

#ifndef LOG_ENAINT_LEAVE
#define LOG_ENAINT_LEAVE()
#endif /* LOG_ENAINT_LEAVE */

#ifndef LOG_SUSALL_ENTER
#define LOG_SUSALL_ENTER()
#endif /* LOG_SUSALL_ENTER */

#ifndef LOG_SUSALL_LEAVE
#define LOG_SUSALL_LEAVE()
#endif /* LOG_SUSALL_LEAVE */

#ifndef LOG_RSMALL_ENTER
#define LOG_RSMALL_ENTER()
#endif /* LOG_RSMALL_ENTER */

#ifndef LOG_RSMALL_LEAVE
#define LOG_RSMALL_LEAVE()
#endif /* LOG_RSMALL_LEAVE */

#ifndef LOG_SUSOSI_ENTER
#define LOG_SUSOSI_ENTER()
#endif /* LOG_SUSOSI_ENTER */

#ifndef LOG_SUSOSI_LEAVE
#define LOG_SUSOSI_LEAVE()
#endif /* LOG_SUSOSI_LEAVE */

#ifndef LOG_RSMOSI_ENTER
#define LOG_RSMOSI_ENTER()
#endif /* LOG_RSMOSI_ENTER */

#ifndef LOG_RSMOSI_LEAVE
#define LOG_RSMOSI_LEAVE()
#endif /* LOG_RSMOSI_LEAVE */

#ifndef LOG_GETISRID_ENTER
#define LOG_GETISRID_ENTER()
#endif /* LOG_GETISRID_ENTER */

#ifndef LOG_GETISRID_LEAVE
#define LOG_GETISRID_LEAVE(ercd)
#endif /* LOG_GETISRID_LEAVE */

#ifndef LOG_DISINTSRC_ENTER
#define LOG_DISINTSRC_ENTER(isrid)
#endif /* LOG_DISINTSRC_ENTER */

#ifndef LOG_DISINTSRC_LEAVE
#define	LOG_DISINTSRC_LEAVE(ercd)
#endif /* LOG_DISINTSRC_LEAVE */

#ifndef LOG_ENAINTSRC_ENTER
#define LOG_ENAINTSRC_ENTER(isrid)
#endif /* LOG_ENAINTSRC_ENTER */

#ifndef LOG_ENAINTSRC_LEAVE
#define	LOG_ENAINTSRC_LEAVE(ercd)
#endif /* LOG_ENAINTSRC_LEAVE */

/*
 *  ٤Ƥγߤζػߡʹ®ʰǡ
 *  ߶ػ߾֤ذܹ
 */
#ifdef TOPPERS_DisableAllInterrupts

#ifndef OMIT_STANDARD_DISALLINT

void
DisableAllInterrupts(void)
{
	LOG_DISINT_ENTER();
	if ((get_my_p_ccb()->callevel_stat & (TSYS_DISALLINT | TSYS_SUSALLINT | TSYS_SUSOSINT)) == TSYS_NULL) {
		x_lock_all_int();
		ENTER_CALLEVEL(TSYS_DISALLINT);
	}
	LOG_DISINT_LEAVE();
}

#endif /* OMIT_STANDARD_DISALLINT */

#endif /* TOPPERS_DisableAllInterrupts */

/*
 *  ٤Ƥγߤεġʹ®ʰǡ
 *  ߶ػ߾֤
 */
#ifdef TOPPERS_EnableAllInterrupts

#ifndef OMIT_STANDARD_DISALLINT

void
EnableAllInterrupts(void)
{
	CCB *p_ccb = get_my_p_ccb();

	LOG_ENAINT_ENTER();
	if ((p_ccb->callevel_stat & (TSYS_SUSALLINT | TSYS_SUSOSINT)) == TSYS_NULL) {
		if ((p_ccb->callevel_stat & TSYS_DISALLINT) != TSYS_NULL) {
			LEAVE_CALLEVEL(TSYS_DISALLINT);
			x_unlock_all_int();
		}
	}
	LOG_ENAINT_LEAVE();
}

#endif /* OMIT_STANDARD_DISALLINT */

#endif /* TOPPERS_EnableAllInterrupts */

/*
 *  ߶ػ
 *  CPUƤγߤоݤγ߶ػ(ͥȥͭ)
 */
#ifdef TOPPERS_SuspendAllInterrupts

void
SuspendAllInterrupts(void)
{
#ifdef CFG_USE_ERRORHOOK
	StatusType	ercd;
#endif /* CFG_USE_ERRORHOOK */
	CCB			*p_ccb = get_my_p_ccb();

	LOG_SUSALL_ENTER();
	S_N_CHECK_DISALLINT();
	/* ͥȲξĶ */
	S_N_CHECK_LIMIT(p_ccb->sus_all_cnt != UINT8_INVALID);

	if (p_ccb->sus_all_cnt == 0U) {
		x_lock_all_int();
		ENTER_CALLEVEL(TSYS_SUSALLINT);
	}

	p_ccb->sus_all_cnt++;
	p_ccb->sus_all_cnt_ctx++;

  exit_no_errorhook:
	LOG_SUSALL_LEAVE();
	return;

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
	call_errorhook(ercd, OSServiceId_SuspendAllInterrupts);
	x_nested_unlock_os_int();
	goto exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_SuspendAllInterrupts */

/*
 *  ߶ػ߲
 *  CPUƤγߤоݤγߵ(ͥȥͭ)
 */
#ifdef TOPPERS_ResumeAllInterrupts

void
ResumeAllInterrupts(void)
{
#ifdef CFG_USE_ERRORHOOK
	StatusType	ercd;
#endif /* CFG_USE_ERRORHOOK */
	CCB			*p_ccb = get_my_p_ccb();

	LOG_RSMALL_ENTER();
	S_N_CHECK_DISALLINT();
	S_N_CHECK_STATE(p_ccb->sus_all_cnt_ctx != 0U);
	S_N_CHECK_STATE(p_ccb->sus_all_cnt > p_ccb->wrap_sus_all_cnt);

	p_ccb->sus_all_cnt--;
	p_ccb->sus_all_cnt_ctx--;

	if (p_ccb->sus_all_cnt == 0U) {
		LEAVE_CALLEVEL(TSYS_SUSALLINT);
		x_unlock_all_int();
	}

  exit_no_errorhook:
	LOG_RSMALL_LEAVE();
	return;

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
	call_errorhook(ercd, OSServiceId_ResumeAllInterrupts);
	x_nested_unlock_os_int();
	goto exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_ResumeAllInterrupts */

/*
 *  OSߤζػ
 *  C2ISRоݤγ߶ػ(ͥȥͭ)
 */
#ifdef TOPPERS_SuspendOSInterrupts

void
SuspendOSInterrupts(void)
{
#ifdef CFG_USE_ERRORHOOK
	StatusType	ercd;
#endif /* CFG_USE_ERRORHOOK */
	CCB			*p_ccb = get_my_p_ccb();

	LOG_SUSOSI_ENTER();
	S_N_CHECK_DISALLINT();
	/* ͥȲξĶ */
	S_N_CHECK_LIMIT(p_ccb->sus_os_cnt != UINT8_INVALID);

	if (p_ccb->sus_os_cnt == 0U) {
		x_suspend_lock_os_int();
		ENTER_CALLEVEL(TSYS_SUSOSINT);
	}

	p_ccb->sus_os_cnt++;
	p_ccb->sus_os_cnt_ctx++;

  exit_no_errorhook:
	LOG_SUSOSI_LEAVE();
	return;

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
	call_errorhook(ercd, OSServiceId_SuspendOSInterrupts);
	x_nested_unlock_os_int();
	goto exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_SuspendOSInterrupts */

/*
 *  OS߶ػ߲
 *  C2ISRоݤγߵ(ͥȥͭ)
 */
#ifdef TOPPERS_ResumeOSInterrupts

void
ResumeOSInterrupts(void)
{
#ifdef CFG_USE_ERRORHOOK
	StatusType	ercd;
#endif /* CFG_USE_ERRORHOOK */
	CCB			*p_ccb = get_my_p_ccb();

	LOG_RSMOSI_ENTER();
	S_N_CHECK_DISALLINT();
	S_N_CHECK_STATE(p_ccb->sus_os_cnt_ctx != 0U);
	S_N_CHECK_STATE(p_ccb->sus_os_cnt > p_ccb->wrap_sus_os_cnt);

	p_ccb->sus_os_cnt--;
	p_ccb->sus_os_cnt_ctx--;

	if (p_ccb->sus_os_cnt == 0U) {
		LEAVE_CALLEVEL(TSYS_SUSOSINT);
		x_resume_unlock_os_int();
	}

  exit_no_errorhook:
	LOG_RSMOSI_LEAVE();
	return;

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
	call_errorhook(ercd, OSServiceId_ResumeOSInterrupts);
	x_nested_unlock_os_int();
	goto exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_ResumeOSInterrupts */

/*
 *  C2ISR IDμ
 */
#ifdef TOPPERS_GetISRID

ISRType
GetISRID(void)
{
	ISRType		isrid;
	StatusType	ercd;
	CCB			*p_ccb = get_my_p_ccb();

	LOG_GETISRID_ENTER();
	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_GETISRID);

	isrid = (p_ccb->p_runisr == NULL) ? INVALID_ISR : ISR2ID(p_ccb->p_runisr);

  exit_finish:
	LOG_GETISRID_LEAVE(isrid);
	return(isrid);

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
	/*
	 *  顼ȯINVALID_ISRID֤뤬顼ȯΤ¹
	 *  C2ISR¸ߤʤΤ̤뤿ᡤ顼եåƤ
	 */
	call_errorhook(ercd, OSServiceId_GetISRID);
	x_nested_unlock_os_int();
#endif /* CFG_USE_ERRORHOOK */

  exit_no_errorhook:
	isrid = INVALID_ISR;
	goto exit_finish;
}

#endif /* TOPPERS_GetISRID */

/*
 *  ߤζػ
 */
#ifdef TOPPERS_DisableInterruptSource

StatusType
DisableInterruptSource(ISRType DisableISR)
{
	ISRCB		*p_isrcb;
	StatusType	ercd;
	CCB			*my_p_ccb;

	LOG_DISINTSRC_ENTER(DisableISR);
	CHECK_CALLEVEL(CALLEVEL_DISABLEINTERRUPTSOURCE);
	CHECK_ID(DisableISR < tnum_isr2);
	p_isrcb = get_isrcb(DisableISR);
	CHECK_CORE(p_isrcb->p_isrinib != NULL);
	CHECK_CORE(GET_ISR_COREID(p_isrcb) == x_core_id());
	CHECK_ACS(p_isrcb->p_isrinib->acsbtmp);

	if (DisableISR < (tnum_isr2 - tnum_ici)) {
		/* C2ISR */
		x_disable_int(GET_INTNO(p_isrcb));
	}
	else {
		/* ICISR */
		my_p_ccb = get_my_p_ccb();
		x_nested_lock_os_int();
		acquire_tsk_lock(my_p_ccb);

		/* ICISRбӥåȤ򥯥ꥢơֳߤػߤ */
		my_p_ccb->ici_bit_mask &= ~(iciinib_table[DisableISR + tnum_ici - tnum_isr2].ici_bit_ptn);

		release_tsk_lock(my_p_ccb);
		x_nested_unlock_os_int();
	}
	ercd = E_OK;

  exit_no_errorhook:
	LOG_DISINTSRC_LEAVE(ercd);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
#ifdef CFG_USE_PARAMETERACCESS
	get_my_p_ccb()->_errorhook_par1.isrid = DisableISR;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_DisableInterruptSource);
	x_nested_unlock_os_int();
	goto exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_DisableInterruptSource */

/*
 *  ߤε
 */
#ifdef TOPPERS_EnableInterruptSource

StatusType
EnableInterruptSource(ISRType EnableISR)
{
	ISRCB		*p_isrcb;
	StatusType	ercd;
	CCB			*my_p_ccb;

	LOG_ENAINTSRC_ENTER(EnableISR);
	CHECK_CALLEVEL(CALLEVEL_ENABLEINTERRUPTSOURCE);
	CHECK_ID(EnableISR < tnum_isr2);
	p_isrcb = get_isrcb(EnableISR);
	CHECK_CORE(p_isrcb->p_isrinib != NULL);
	CHECK_CORE(GET_ISR_COREID(p_isrcb) == x_core_id());
	CHECK_ACS(p_isrcb->p_isrinib->acsbtmp);

	if (EnableISR < (tnum_isr2 - tnum_ici)) {
		/* C2ISR */
		x_enable_int(GET_INTNO(p_isrcb));
	}
	else {
		/* ICISR */
		my_p_ccb = get_my_p_ccb();
		x_nested_lock_os_int();
		acquire_tsk_lock(my_p_ccb);

		/* ICISRбӥåȤ򥻥åȤơֳߤĤ */
		my_p_ccb->ici_bit_mask |= iciinib_table[EnableISR + tnum_ici - tnum_isr2].ici_bit_ptn;

		/* ߥӥåȤåȤ줿硤ФƥֳߤȯԤ */
		if ((my_p_ccb->ici_request_map & iciinib_table[EnableISR + tnum_ici - tnum_isr2].ici_bit_ptn) != 0U) {
			target_ici_raise(my_p_ccb->coreid);
		}
		release_tsk_lock(my_p_ccb);
		x_nested_unlock_os_int();
	}
	ercd = E_OK;

  exit_no_errorhook:
	LOG_ENAINTSRC_LEAVE(ercd);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
#ifdef CFG_USE_PARAMETERACCESS
	get_my_p_ccb()->_errorhook_par1.isrid = EnableISR;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_EnableInterruptSource);
	x_nested_unlock_os_int();
	goto exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_EnableInterruptSource */
