/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: task_manage.c 7087 2013-02-28 03:49:22Z fsi-ikegaya $
 */

/*
 *		⥸塼
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_TSKSTAT
#define LOG_TSKSTAT(p_tcb)
#endif /* LOG_TSKSTAT */

#ifndef LOG_ACTTSK_ENTER
#define LOG_ACTTSK_ENTER(tskid)
#endif /* LOG_ACTTSK_ENTER */

#ifndef LOG_ACTTSK_LEAVE
#define LOG_ACTTSK_LEAVE(ercd)
#endif /* LOG_ACTTSK_LEAVE */

#ifndef LOG_TERTSK_ENTER
#define LOG_TERTSK_ENTER()
#endif /* LOG_TERTSK_ENTER */

#ifndef LOG_TERTSK_LEAVE
#define LOG_TERTSK_LEAVE(ercd)
#endif /* LOG_TERTSK_LEAVE */

#ifndef LOG_CHNTSK_ENTER
#define LOG_CHNTSK_ENTER(tskid)
#endif /* LOG_CHNTSK_ENTER */

#ifndef LOG_CHNTSK_LEAVE
#define LOG_CHNTSK_LEAVE(ercd)
#endif /* LOG_CHNTSK_LEAVE */

#ifndef LOG_SCHED_LEAVE
#define LOG_SCHED_ENTER()
#endif /* LOG_SCHED_LEAVE */

#ifndef LOG_SCHED_LEAVE
#define LOG_SCHED_LEAVE(ercd)
#endif /* LOG_SCHED_LEAVE */

#ifndef LOG_GETTID_ENTER
#define LOG_GETTID_ENTER()
#endif /* LOG_GETTID_ENTER */

#ifndef LOG_GETTID_LEAVE
#define LOG_GETTID_LEAVE(ercd, p_tskid)
#endif /* LOG_GETTID_LEAVE */

#ifndef LOG_GETTST_ENTER
#define LOG_GETTST_ENTER(tskid)
#endif /* LOG_GETTST_ENTER */

#ifndef LOG_GETTST_LEAVE
#define LOG_GETTST_LEAVE(ercd, p_state)
#endif /* LOG_GETTST_LEAVE */


/*
 *  εư
 */
#ifdef TOPPERS_ActivateTask

StatusType
ActivateTask(TaskType TaskID)
{
	StatusType	ercd = E_OK;
	TCB			*p_tcb;
	boolean		dspreq = FALSE;
	CCB			*p_ccb;

	LOG_ACTTSK_ENTER(TaskID);
	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_ACTIVATETASK);
	CHECK_ID(TaskID < tnum_task);
	p_tcb = get_tcb(TaskID);
	CHECK_CORE(p_tcb->p_tinib != NULL);
	CHECK_ACS(p_tcb->p_tinib->acsbtmp);
	p_ccb = p_tcb->p_tinib->p_ccb;

	x_nested_lock_os_int();
	acquire_tsk_lock(p_ccb);

	if (p_tcb->tstat == SUSPENDED) {
		if (make_active(p_tcb) != FALSE) {
			/*
			 *  tskid¾ǤХǥѥå׵
			 *  ǤĥƥȤƤӽФƤdspreq򿿤
			 */
			if ((dispatch_request(p_ccb) != FALSE) && (p_ccb->callevel_stat == TCL_TASK)) {
				dspreq = TRUE;
			}
		}
	}
	else {
		S_D_CHECK_LIMIT(p_tcb->actcnt < p_tcb->p_tinib->maxact);

		p_tcb->actcnt += 1U;
	}

	release_tsk_lock_and_dispatch(p_ccb, dspreq);
	x_nested_unlock_os_int();

  exit_no_errorhook:
	LOG_ACTTSK_LEAVE(ercd);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  d_exit_errorhook:
	release_tsk_lock(p_ccb);
	goto errorhook_start;

  exit_errorhook:
	x_nested_lock_os_int();
  errorhook_start:
#ifdef CFG_USE_PARAMETERACCESS
	get_my_p_ccb()->_errorhook_par1.tskid = TaskID;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_ActivateTask);
#else /* CFG_USE_ERRORHOOK */
  d_exit_no_errorhook:
	release_tsk_lock(p_ccb);
#endif /* CFG_USE_ERRORHOOK */
	x_nested_unlock_os_int();
	goto exit_no_errorhook;
}

#endif /* TOPPERS_ActivateTask */

/*
 *  νλ
 */
#ifdef TOPPERS_TerminateTask

StatusType
TerminateTask(void)
{
	StatusType	ercd = E_OK;
	CCB			*p_ccb = get_my_p_ccb();

	LOG_TERTSK_ENTER();
	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_TERMINATETASK);
	CHECK_RESOURCE(p_ccb->p_runtsk->p_lastrescb == NULL);
	CHECK_SPINLOCK(p_ccb->p_runtsk->p_lastspncb == NULL);

	x_nested_lock_os_int();
	acquire_tsk_lock(p_ccb);
	/*
	 *  ꥽βͥ٤򲼤ʤΤǡǤ
	 *  ⤷ʤƤ褤
	 */

	suspend(p_ccb);

	release_tsk_lock(p_ccb);
	LOG_TERTSK_LEAVE(E_OK);
	exit_and_dispatch();
	/* ˤäƤʤ */

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
	call_errorhook(ercd, OSServiceId_TerminateTask);
	x_nested_unlock_os_int();
#endif /* CFG_USE_ERRORHOOK */

  exit_no_errorhook:
	LOG_TERTSK_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_TerminateTask */

/*
 *  νλȥεư
 */
#ifdef TOPPERS_ChainTask

StatusType
ChainTask(TaskType TaskID)
{
	/*
	 *  Ǥ ercd νפǤ뤬ѥη
	 *  å򤱤뤿˽Ƥ
	 */
	StatusType	ercd = E_OK;
	TCB			*p_tcb;
	CCB			*my_p_ccb;
	CCB			*t_p_ccb;
	CCB			*lock_p_ccb;

	LOG_CHNTSK_ENTER(TaskID);
	my_p_ccb = get_my_p_ccb();

	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_CHAINTASK);
	CHECK_RESOURCE(my_p_ccb->p_runtsk->p_lastrescb == NULL);
	CHECK_SPINLOCK(my_p_ccb->p_runtsk->p_lastspncb == NULL);
	CHECK_ID(TaskID < tnum_task);
	p_tcb = get_tcb(TaskID);
	CHECK_CORE(p_tcb->p_tinib != NULL);
	CHECK_ACS(p_tcb->p_tinib->acsbtmp);
	t_p_ccb = p_tcb->p_tinib->p_ccb;

	if (my_p_ccb == t_p_ccb) {
		/*
		 * λȸ³Ʊ˳դƤ
		 */
		lock_p_ccb = my_p_ccb;
		x_nested_lock_os_int();
		acquire_tsk_lock(lock_p_ccb);

		if (p_tcb == my_p_ccb->p_runtsk) {
			make_non_runnable(my_p_ccb);
			(void) make_active(my_p_ccb->p_runtsk);
		}
		else {
			/*
			 *  顼ѤĤʤ褦ˡ顼å
			 *  λ˹Ԥɬפ
			 */
			S_D_CHECK_LIMIT((p_tcb->tstat == SUSPENDED)
							|| (p_tcb->actcnt < p_tcb->p_tinib->maxact));

			suspend(my_p_ccb);

			if (p_tcb->tstat == SUSPENDED) {
				(void) make_active(p_tcb);
			}
			else {
				p_tcb->actcnt += 1U;
			}
		}
	}
	else {
		/*
		 * λȸ³ۤʤ륳˳դƤ
		 */
		lock_p_ccb = t_p_ccb;
		x_nested_lock_os_int();
		acquire_tsk_lock(lock_p_ccb);

		/*
		 *  顼ѤĤʤ褦ˡ顼å
		 *  λ˹Ԥɬפ
		 */
		S_D_CHECK_LIMIT((p_tcb->tstat == SUSPENDED)
						|| (p_tcb->actcnt < p_tcb->p_tinib->maxact));
		if (p_tcb->tstat == SUSPENDED) {
			if (make_active(p_tcb) != FALSE) {
				/* ǥѥå׵ */
				(void) dispatch_request(t_p_ccb);
			}
		}
		else {
			p_tcb->actcnt += 1U;
		}
		release_tsk_lock(lock_p_ccb);
		x_nested_unlock_os_int();

		/* λ */
		x_nested_lock_os_int();
		acquire_tsk_lock(my_p_ccb);
		suspend(my_p_ccb);
		lock_p_ccb = my_p_ccb;
	}
	release_tsk_lock(lock_p_ccb);
	LOG_CHNTSK_LEAVE(E_OK);
	exit_and_dispatch();
	/* ˤäƤʤ */

#ifdef CFG_USE_ERRORHOOK
  d_exit_errorhook:
	release_tsk_lock(lock_p_ccb);
	goto errorhook_start;

  exit_errorhook:
	x_nested_lock_os_int();
  errorhook_start:
#ifdef CFG_USE_PARAMETERACCESS
	my_p_ccb->_errorhook_par1.tskid = TaskID;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_ChainTask);
#else /* CFG_USE_ERRORHOOK */
  d_exit_no_errorhook:
	release_tsk_lock(lock_p_ccb);
#endif /* CFG_USE_ERRORHOOK */
	x_nested_unlock_os_int();
  exit_no_errorhook:
	LOG_CHNTSK_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_ChainTask */

/*
 *  塼θƤӽФ
 */
#ifdef TOPPERS_Schedule

StatusType
Schedule(void)
{
	/*
	 *  Ǥ ercd νפǤ뤬ѥη
	 *  å򤱤뤿˽Ƥ
	 */
	StatusType	ercd = E_OK;
	CCB			*p_ccb = get_my_p_ccb();

	LOG_SCHED_ENTER();
	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_SCHEDULE);
	CHECK_RESOURCE(p_ccb->p_runtsk->p_lastrescb == NULL);
	CHECK_SPINLOCK(p_ccb->p_runtsk->p_lastspncb == NULL);

	x_nested_lock_os_int();
	acquire_tsk_lock(p_ccb);
	if (p_ccb->p_runtsk->p_tinib->inipri > p_ccb->nextpri) {
		p_ccb->p_runtsk->curpri = p_ccb->p_runtsk->p_tinib->inipri;
		preempt(p_ccb);
		release_tsk_lock(p_ccb);
		dispatch();
		p_ccb->p_runtsk->curpri = p_ccb->p_runtsk->p_tinib->exepri;
	}
	else {
		release_tsk_lock(p_ccb);
	}

  d_exit_no_errorhook:
	x_nested_unlock_os_int();
  exit_no_errorhook:
	LOG_SCHED_LEAVE(ercd);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
	call_errorhook(ercd, OSServiceId_Schedule);
	goto d_exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_Schedule */

/*
 *  ¹Ծ֤ΥIDλ
 */
#ifdef TOPPERS_GetTaskID

StatusType
GetTaskID(TaskRefType TaskID)
{
	StatusType	ercd = E_OK;
	CCB			*p_ccb = get_my_p_ccb();

	LOG_GETTID_ENTER();
	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_GETTASKID);
	CHECK_PARAM_POINTER(TaskID);
	CHECK_MEM_WRITE(TaskID, TaskType);
	*TaskID = (p_ccb->p_runtsk == NULL) ? INVALID_TASK : TSKID(p_ccb->p_runtsk);

  exit_no_errorhook:
	LOG_GETTID_LEAVE(ercd, TaskID);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
#ifdef CFG_USE_PARAMETERACCESS
	p_ccb->_errorhook_par1.p_tskid = TaskID;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_GetTaskID);
	x_nested_unlock_os_int();
	goto exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_GetTaskID */

/*
 *  ֤λ
 */
#ifdef TOPPERS_GetTaskState

StatusType
GetTaskState(TaskType TaskID, TaskStateRefType State)
{
	StatusType	ercd = E_OK;
	TCB			*p_tcb;
	CCB			*p_ccb;

	LOG_GETTST_ENTER(TaskID);
	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_GETTASKSTATE);
	CHECK_ID(TaskID < tnum_task);
	CHECK_PARAM_POINTER(State);
	CHECK_MEM_WRITE(State, TaskStateType);
	p_tcb = get_tcb(TaskID);
	CHECK_CORE(p_tcb->p_tinib != NULL);
	CHECK_ACS(p_tcb->p_tinib->acsbtmp);
	p_ccb = p_tcb->p_tinib->p_ccb;

	*State = (p_tcb == p_ccb->p_runtsk) ? RUNNING : p_tcb->tstat;

  exit_no_errorhook:
	LOG_GETTST_LEAVE(ercd, State);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
#ifdef CFG_USE_PARAMETERACCESS
	get_my_p_ccb()->_errorhook_par1.tskid = TaskID;
	get_my_p_ccb()->_errorhook_par2.p_stat = State;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_GetTaskState);
	x_nested_unlock_os_int();
	goto exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_GetTaskState */

/*
 *  λѥεư
 *
 *  OS߶ػ߾֤ǸƤФ
 */
#ifdef TOPPERS_activate_task_action

void
activate_task_action(TaskType TaskID)
{
	StatusType	ercd = E_OK;
	TCB			*p_tcb;
	CCB			*p_ccb;

	LOG_ACTTSK_ENTER(TaskID);
	p_tcb = get_tcb(TaskID);
	CHECK_CORE(p_tcb->p_tinib != NULL);
	p_ccb = p_tcb->p_tinib->p_ccb;

	acquire_tsk_lock(p_ccb);

	if (p_tcb->tstat == SUSPENDED) {
		if (make_active(p_tcb) != FALSE) {
			(void) dispatch_request(p_ccb);
		}
	}
	else {
		S_D_CHECK_LIMIT(p_tcb->actcnt < p_tcb->p_tinib->maxact);

		p_tcb->actcnt += 1U;
	}

  d_exit_no_errorhook:
	release_tsk_lock(p_ccb);
  exit_no_errorhook:
	LOG_ACTTSK_LEAVE(ercd);
	return;

#ifdef CFG_USE_ERRORHOOK
  d_exit_errorhook:
	release_tsk_lock(p_ccb);
  exit_errorhook:
#ifdef CFG_USE_PARAMETERACCESS
	get_my_p_ccb()->_errorhook_par1.tskid = TaskID;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_ActivateTask);
	goto exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_activate_task_action */
