/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: sample1.c 7679 2013-07-03 03:45:55Z fsi-dankei $
 */

/*
 *		ץץ(1)
 *
 *  ATK2-SC3δŪưǧ뤿Υץץࡥ
 *
 *  ץγסPCȥܡɴ֤ǥꥢ̿Ԥ桼
 *  ޥɤ˱ưȥϤԤʤ
 *
 *  㥳ޥɰ
 *  
 *    '1' : ʹߤΥޥɤ Task1 ФƹԤ
 *    '2' : ʹߤΥޥɤ Task2 ФƹԤ
 *    '3' : ʹߤΥޥɤ Task3 ФƹԤ
 *    '4' : ʹߤΥޥɤ Task4 ФƹԤ
 *    '5' : ʹߤΥޥɤ Task5 ФƹԤ
 *    '6' : ʹߤΥޥɤ Task6 ФƹԤ
 *    '7' : ʹߤΥޥɤ Task7 ФƹԤ
 *    '8' : ʹߤΥޥɤ Task8 ФƹԤ(ޥɻѤǤʤ)
 *    '9' : ʹߤΥޥɤ Task9 ФƹԤ(ޥɻѤǤʤ)
 *  ǽ
 *    'a' : ActivateTask ˤƥư롥
 *    'A' : TerminateTask ˤƥλ롥
 *    '!'(Shift+1) : ChainTask ˤƥλTask1 ư
 *    '"'(Shift+2) : ChainTask ˤƥλTask2 ư
 *    '#'(Shift+3) : ChainTask ˤƥλTask3 ư
 *    '$'(Shift+4) : ChainTask ˤƥλTask4 ư
 *    '%'(Shift+5) : ChainTask ˤƥλTask5 ư
 *    's' : Υץꥨץƥ°Ǥ륿 MainTask ˤƺǹ
 *          ͥ٥ HighPriorityTask ưSchedule ˤ
 *          ƥ塼󥰤Ԥ
 *    'S' : Υץꥨץƥ֥ NonPriTask ư
 *          Υץꥨץƥ֥ NonPriTask ˤƺǹͥ
 *           HighPriorityTask ưλ
 *    'y' : 11(åͭ)ƤӽФؿǽԤ
 *    'Y' : 12(åͭ)ƤӽФؿǽԤ
 *          λˤꡤ顼ɤE_OS_MISSINGEND
 *          顼եåƤФ
 *    'z' : ¹Υ GetTaskID ¹Ԥơ¹Ծ֤ TaskID 
 *    'Z' : ᥤ󥿥 GetTaskState ¹Ԥơоݥξ֤
 *    'x' : div̿¹Ԥơ̤̿㳰ȯ
 *  ߴǽ
 *    'd' : DisableAllInterrupts ¹Ը塤ߥޡͤ3ɽ
 *           EnableAllInterrupts ¹Ԥ
 *    'D' : SuspendAllInterrupts ¹Ը塤ߥޡͤ3ɽ
 *           SuspendAllInterrupts ¹Ը塢ߥ
 *          ޡͤ3ɽResumeAllInterrupts ¹Ը塢
 *          ޡͤ3ɽResumeAllInterrupts ¹Ԥ
 *    'f' : SuspendOSInterrupts ¹Ը塤ߥޡͤ3ɽ
 *           SuspendOSInterrupts ¹Ը塢ߥ
 *          ޡͤ3ɽ SuspendAllInterrupts¹
 *          塤ߥޡͤ3ɽ ResumeAllInterrupts
 *          ¹Ը塢ߥޡͤ3ɽ
 *          ResumeOSInterrupts ¹Ըߥޡͤ3ɽ
 *          ResumeOSInterrupts ¹Ԥ
 *    'T' : ߥޡͤ3ɽ
 *  ꥽ǽ
 *    'k' : GetResource ˤƥ꥽ TskLevelRes 롥ʤ
 *          Task3 ϡΥ꥽ͥ٤⤤ᥨ顼Ȥʤ
 *    'K' : ReleaseResource ˤƥ꥽ TskLevelRes 
 *    'i' : GetResource ˤƥ꥽ CntRes 塤
 *          ޡͤ3ɽReleaseResource ˤƥ꥽
 *           CntRes 
 *  ٥浡ǽ
 *    'e' : SetEvent ˤƥ٥Ȥꤹ롥Task2  Task3 ʳ
 *          Ƥʤᥨ顼Ȥʤ
 *    'w' : ClearEvent ˤƼΥ٥Ȥ򥯥ꥢ롥Task2 
 *          Task3 ʳϳƤʤᥨ顼Ȥʤ
 *    'E' : GetEvent ˤƥ٥Ⱦ֤롥Task2  Task3
 *          ʳϳƤʤᥨ顼Ȥʤ
 *    'W' : WaitEvent ˤƼΥ٥ȤԤġTask3  Task4
 *          ʳϥ顼Ȥʤ
 *  顼ൡǽ
 *    'b' : GetAlarmBase ˤƥ顼 MainCycArm Υ顼١
 *          
 *    'B' : GetAlarm ˤƥ顼 MainCycArm λĤꥫͤ2
 *          Ϣ³Ǽ
 *    'v' : SetRelAlarm ˤƥ顼 ActTskArm ư500ms 
 *           Task1 ư
 *    'V' : SetRelAlarm ˤƥ顼 SetEvtArm ư500ms 
 *          ٥ T3Evt ꤹ
 *    'h' : CancelAlarm ˤƥ顼 ActTskArm 򥭥󥻥뤹
 *  ǽ
 *    'c' : ˤ IncrementCounter ¹Ԥ SampleCnt
 *          ˥ʥΤ
 *          1 ʥǥ顼 SampleArm λХå
 *          ¹Ԥ
 *    'C' : ˤ IncrementCounter ¹Ԥ SampleCnt2
 *          ˥ʥΤ
 *          1 ʥǥ顼 SampleArm1 λSampleCnt3 
 *          󥯥Ȥ롥 SampleCnt3  1 ʥ SampleAlm2
 *          λХå¹Ԥ
 *    'j' : ˤ GetCounterValue ¹Ԥ
 *          ͤ¸
 *    'J' : ˤ GetEalsedCounterValue ¹Ԥ
 *          ͤGetCounterValue ޤ GetEalsedCounterValue ˤƼ
 *          ͤȤ롥󡤤ޤϡGetCounterValue¹ԤƤʤ0
 *          Ȥ
 *
 *    'r' : ˤ GetISRID¹Ԥ
 *          ƥȤGetISRIDƽФϥ顼Ȥ
 *          INVALID_ISRֵѤ
 *
 *          ߥƥȤGetISRIDȯԤϡSystemTimerCntΥХå
 *          롼'n' ޥɤǼ¹ԡˤˤƹԤ
 *
 *          ƥȤGetISRIDȯԤϡSampleCnt2ΥХå
 *          롼'C' ޤ 'c' ޥɤǼ¹ԡˤˤƹԤ
 *
 *  塼ơ֥浡ǽ
 *    't' : 塼ơ֥ưON/OFF
 *
 *        'i' : SchtblSampleCnt󥿤򥤥󥯥Ȥ
 *              SchtblSampleCnt󥿤ϥ塼ơ֥ζư
 *        '1' : ʹߤΥޥɤ scheduletable1 ФƹԤ(ǥե)
 *        '2' : ʹߤΥޥɤ scheduletable2 ФƹԤ
 *        '3' : ʹߤΥޥɤ scheduletable3(¸ߤʤID) ФƹԤ
 *              ޥɤΥ顼ǧˤѤ
 *        's' : StartScheduleTableRel¹Ԥ(5)ǥ塼ơ֥򳫻Ϥ
 *        'S' : StartScheduleTableAbs¹Ԥ(5)ǥ塼ơ֥򳫻Ϥ
 *        'f' : StopScheduleTable¹Ԥ塼ơ֥ߤ
 *        'n' : NextScheduleTable¹Ԥscheduletable2ؤ
 *        'N' : NextScheduleTable¹Ԥscheduletable1ؤ
 *        'g' : GetScheduleTableStatus¹Ԥ塼ơ֥֤
 *        'q' : ShutdownAllCores( E_OK ) OS¹浡ǽ'q'Ʊǽ
 *        'Q' : ShutdownAllCores( E_OS_STATE ) OS¹浡ǽ'Q'Ʊǽ
 *
 *  IOCǽ
 *    'I' : IOC⡼
 *
 *        IOC APIѤ륿(IocTaskX)
 *        '1' : IocTask1(OSAP_CORE0˽°)
 *        '2' : IocTask1(OSAP_CORE0˽°)
 *        '3' : IocTask1(OSAP_CORE1˽°)
 *        '4' : IocTask1(OSAP_CORE1˽°)
 *
 *        IOC API
 *        '1' : IocSend_IOC_QUE_0(uint8 in1)
 *        '2' : IocSend_IOC_QUE_1(uint8 in1)
 *        '3' : IocWriteGroup_IOC_DEQUE(uint8 in1, uint8 in2, uint8 in3)
 *        '4' : IocReceive_IOC_QUE(uint8 *out1)
 *        '5' : IocReadGroup_IOC_DEQUE(uint8 *out1, uint8 *out2, uint8 *out3)
 *        '6' : IocEmptyQueue_IOC_QUE(void)
 *
 *        APIǡϤ
 *
 *        ޤIocTaskǥޥɤդ뤿ᡤܥ⡼ǤMainTaskԤ(IocEvt)Ȥʤ
 *
 *  OS¹浡ǽ
 *    'p' : GetActiveApplicationMode ˤƥץꥱ⡼ɤ
 *          
 *    'q' : ShutdownAllCores 򥳡 E_OK Ǽ¹Ԥץץ
 *          λ
 *    'Q' : ShutdownAllCores 򥳡 E_OS_STATE Ǽ¹Ԥץץ
 *          λ
 *
 *  㥪֥Ȱ
 *  OS
 *    ȥåץեå
 *    åȥեå
 *    顼եå
 *    ץ쥿եå̤
 *    ݥȥեå̤
 *  
 *  ᥤ󥿥
 *    IDMainTask
 *    ͥ١14
 *    ¿ŵư1
 *    塼롧Υץꥨץƥ
 *    OSץꥱ˽°(1°)
 *    ưưAppMode1, AppMode2, AppMode3
 *    ס桼󥿥եʥꥢIOꥳޥɤ
 *          бưԤʤ
 *          顼 MainCycArm ˤꡤ100msȤԤ
 *          ޥɤμ̵ͭݡ󥰤
 *          ٥ȡIDMainEvt0, IocEvtˤϢդƤ
 *  ǹͥ٥
 *    IDHighPriorityTask
 *    ͥ١15
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    OSץꥱ˽°(1°)
 *    ưưʤ
 *    סưϤƽλ롥Υץꥨץƥ֥
 *          鵯ư졤ץꥨץȤƤ뤫ɤγǧ
 *  Υץꥨץƥ֥
 *    IDNonPriTask
 *    ͥ١1
 *    ¿ŵư8
 *    塼롧Υץꥨץƥ
 *    ưưʤ
 *    OSץꥱ˽°(1°)
 *    סưϤǹͥ٥ HighPriorityTask 
 *          ư塤λϤƥλ
 *  1
 *    IDTask1
 *    ͥ١4
 *    塼롧եץꥨץƥ
 *    OSץꥱ˽°(1°)
 *    ưưAppMode2
 *    ¿ŵư8
 *    סʥᥤ󥿥λˤư
 *          ư줹ȥԥåTask9ưƤ顤
 *          lock_var1lock_var2ѿ򤽤줾쥤󥯥åȤ塤
 *          ԥå롥θ塤¾Фơ
 *          줾쥳ֳߤ򵯤Ƥ̵¥롼פꡤ
 *          ɽ¹Ԥ
 *          ꥽ TskLevelRes ϢդƤ
 *          ꥽ CntRes ϢդƤ
 *  2
 *    IDTask2
 *    ͥ١7
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    OSץꥱ˽°(1°)
 *    ưưʤ
 *    סʥᥤ󥿥λˤư
 *          ư줹̵¥롼פꡤޥɽ¹Ԥ
 *          ꥽ TskLevelRes ϢդƤ
 *          ꥽ CntRes ϢդƤ
 *          ٥ T2Evt ϢդƤ
 *  3
 *    IDTask3
 *    ͥ١12
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    OSץꥱ˽°(1°)
 *    ưưAppMode3
 *    סʥᥤ󥿥λˤư
 *          ư줹̵¥롼פꡤޥɽ¹Ԥ
 *          ٥Ԥ뤳ȤǽǤ
 *          ꥽ CntRes ϢդƤ
 *          ٥ T3Evt ϢդƤ
 *  4
 *    IDTask4
 *    ͥ١6
 *    ¿ŵư5
 *    塼롧եץꥨץƥ
 *    OSץꥱ˽°(1°)
 *    ưưʤ
 *    סʥᥤ󥿥λˤư
 *          ư줹̵¥롼פꡤޥɽ¹Ԥ
 *          ꥽ TskLevelRes ϢդƤ
 *          ꥽ CntRes ϢդƤ
 *          ꥽ GroupRes ϢդƤ
 *  5
 *    IDTask5
 *    ͥ١9
 *    ¿ŵư5
 *    塼롧եץꥨץƥ
 *    OSץꥱ˽°(1°)
 *    ưưʤ
 *    סʥᥤ󥿥λˤư
 *          ư줹̵¥롼פꡤޥɽ¹Ԥ
 *          ꥽ TskLevelRes ϢդƤ
 *          ꥽ CntRes ϢդƤ
 *          ꥽ GroupRes ϢդƤ
 *  6
 *    IDTask6
 *    ͥ١9
 *    ¿ŵư-
 *    塼롧եץꥨץƥ
 *    ưưAppMode1AppMode2AppMode3
 *    OSץꥱ˽°(0°)
 *    ס
 *          ư줹ʸϼԤˤʤꡤ硤
 *          ʸϤ塤ʬȤChainTask
 *          åϥ桼
 *  7
 *    IDTask7
 *    ͥ١9
 *    ¿ŵư-
 *    塼롧եץꥨץƥ
 *    ưưAppMode1AppMode2AppMode3
 *    OSץꥱ˽°(0°)
 *    סưưȥᥤ󥿥λˤư
 *          ư줹¨ؿλ
 *          ξǤTerminateTask¹Ԥ뤫ǧ
 *          ٵưƤOKȤʤ
 *  8
 *    IDTask8
 *    ͥ١13
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    OSץꥱ˽°(1°)
 *    ưưʤ
 *    סưåϤ٥(T8Evt)Ԥ
 *  9
 *    IDTask9
 *    ͥ١13
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    OSץꥱ˽°(1°)
 *    ưưʤ
 *    סưåϤ٥(T9Evt)Ԥ
 *  10
 *    IDTask10
 *    ͥ١13
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    OSץꥱ˽°(1°)
 *    ưưʤ
 *    סưåϤ٥(T10Evt)Ԥ
 *  11
 *    IDTask11
 *    ͥ١9
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    OSץꥱ˽°(1°)
 *    ưưʤ
 *    סؿưǧ
 *          OSץꥱ˽°
 *          Task12ȥåͭ
 *  12
 *    IDTask12
 *    ͥ١8
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    OSץꥱ˽°(1°)
 *    ưưʤ
 *    סؿưǧ
 *          OSץꥱ˽°
 *          Task11ȥåͭ
 *  13
 *    IDTask13
 *    ͥ١11
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    ưưAppMode1AppMode2AppMode3
 *    ס꥿ưǧ
 *          OSץꥱ˽°(0°)
 *          ưåϸ塤ChainTask(Task14)ȯ
 *  14
 *    IDTask14
 *    ͥ١10
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    ưưʤ
 *    ס꥿ưǧ
 *          OSץꥱ˽°(0°)
 *          Task13ˤ굯ưåϸ彪λ
 *  15
 *    IDTask15
 *    ͥ١11
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    ưưAppMode1AppMode2AppMode3
 *    ס꥿ưǧ
 *          OSץꥱ˽°(1°)
 *          ưåϸ塤ChainTask(Task16)ȯ
 *  16
 *    IDTask16
 *    ͥ١10
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    ưưʤ
 *    ס꥿ưǧ(1°)
 *          OSץꥱ˽°
 *          Task15ˤ굯ưåϸ彪λ
 *  17
 *    IDTask17
 *    ͥ١12
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    ưưʤ
 *    סưåϤԥålock_var1ѿ
 *          󥯥Ȥơԥålock_var2ѿ
 *          󥯥åȤƤlock_var1lock_var2ͤɽ
 *          ԥåλ
 *          ¹ԤƸСlock_var1ͤȤʤꡤlock_var2
 *          ͤȤʤ
 *  IocTask1
 *    IDIocTask1
 *    ͥ١9
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    ưưʤ
 *    סIOC̿(IOC APIǡꡤ¹)Ԥ
 *          OSץꥱ˽°(0°)
 *          ٥ȡIDIocEvtˤϢդƤ
 *  IocTask2
 *    IDIocTask2
 *    ͥ١9
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    ưưʤ
 *    סIOC̿(IOC APIǡꡤ¹)Ԥ
 *          OSץꥱ˽°(0°)
 *          ٥ȡIDIocEvtˤϢդƤ
 *  IocTask3
 *    IDIocTask3
 *    ͥ١9
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    ưưʤ
 *    סIOC̿(IOC APIǡꡤ¹)Ԥ
 *          OSץꥱ˽°(1°)
 *          ٥ȡIDIocEvtˤϢդƤ
 *  IocTask4
 *    IDIocTask4
 *    ͥ١9
 *    ¿ŵư1
 *    塼롧եץꥨץƥ
 *    ưưʤ
 *    סIOC̿(IOC APIǡꡤ¹)Ԥ
 *          OSץꥱ˽°(1°)
 *          ٥ȡIDIocEvtˤϢդƤ
 *
 *  ߥӥ롼
 *  0ΥꥢIO
 *    ISRIDRxHwSerialInt0
 *    ͥ١2
 *    ƥꡧ2
 *    סޥɤ
 *  1ΥꥢIO
 *    ISRIDRxHwSerialInt1
 *    ͥ١2
 *    ƥꡧ2
 *    סʸ
 *  0Υƥॿ޳
 *    ISRIDtarget_timer_hdr0
 *    ͥ١5
 *    ƥꡧ2
 *    סIncrementCounter(SysTimerCnt0) ¹Ԥ
 *  1Υƥॿ޳
 *    ISRIDtarget_timer_hdr1
 *    ͥ١5
 *    ƥꡧ2
 *    סIncrementCounter(SysTimerCnt1) ¹Ԥ
 *  ꥽
 *  ٥꥽
 *    ꥽IDTskLevelRes
 *    ץѥƥɸ
 *  ѥ󥿥꥽
 *    ꥽IDCntRes
 *    ץѥƥɸ
 *  롼ץ꥽
 *    ꥽IDGroupRes
 *    ץѥƥ
 *  ٥
 *  ᥤ󥿥٥
 *    ٥IDMainEvt
 *  2٥
 *    ٥IDT2Evt
 *  3٥
 *    ٥IDT3Evt
 *  
 *  0Υƥॿޥ
 *    IDSysTimerCnt0
 *    ͡0999
 *    û͡1
 *  1Υƥॿޥ
 *    IDSysTimerCnt1
 *    ͡0999
 *    û͡1
 *  ץ륫
 *    IDSampleCnt
 *    ͡099
 *    û͡10
 *  顼
 *  ᥤ顼
 *    顼IDMainCycArm
 *    ١IDSysTimerCnt
 *    󡧥٥ MainEvt
 *    ưưAppMode1, AppMode2, AppMode3
 *    ꡧ100100
 *  ư顼
 *    顼IDActTskArm
 *    ١IDSysTimerCnt
 *    󡧥ư Task1
 *    ưưʤ
 *  ٥ꥢ顼
 *    顼IDSetEvtArm
 *    ١IDSysTimerCnt
 *    󡧥٥ T3Evt
 *    ưưʤ
 *  IncrementCounterǧѥ顼
 *    顼IDSampleArm
 *    ١IDSampleCnt
 *    󡧥Хåؿ¹
 *    ưưʤ
 *  ץꥱ⡼
 *  ưưʤ⡼
 *    ץꥱ⡼IDAppMode1
 *  Task1ưư⡼
 *    ץꥱ⡼IDAppMode2
 *  Task3ưư⡼
 *    ץꥱ⡼IDAppMode3
 *  ؿ
 *    ؿtfnt1
 *      OSץꥱ󤫤Ϥ줿
 *      ݥ󥿰ɽơ׻̤
 *      OSץꥱ֤
 *    ؿtfnt2
 *      OSץꥱ󤫤Ϥ줿
 *      ݥ󥿰ɽơ׻̤
 *      OSץꥱ֤
 *    ؿtfnt3
 *      OSץꥱ󤫤ShutdownOS
 *      դ
 *    ؿtfnt4
 *      OSץꥱ󤫤鿮OSץ
 *      ˽°륿ư
 *
 *  ܥեϥ0˽°Ƥ륪֥,
 *  sample2.cǤϥ1˽°Ƥ륪֥
 *  򵭽ҤƤ
 */

#include "Os.h"
#include "t_syslog.h"
#include "t_stdlib.h"
#include "sysmod/serial.h"
#include "sysmod/syslog.h"
#include "Ioc.h"
#include "sample1.h"

#include "sysmod/banner.h"
#include "target_sysmod.h"
#include "target_serial.h"

extern volatile sint32	lock_var1;          /* ԥåưǧѥХѿ1 */
extern volatile sint32	lock_var2;          /* ԥåưǧѥХѿ2 */

extern void TaskProk(uint8 task_no);
extern uint8 GetCommand(void);
extern void PutActTsk(uint8 task_no);
extern void PutTermTsk(uint8 task_no);
extern void PutChainTsk(uint8 from_task_no, uint8 to_task_no);
extern void PutSchedule(void);
extern void PutTaskID(void);
extern void PutTaskState(uint8 task_no);
extern void PutDisAllInt(void);
extern void PutSusAllInt(void);
extern void PutSusOSInt(void);
extern void PutHwCnt3(void);
extern void PutGetIntRes(void);
extern void PutGetTskRes(void);
extern void PutRelTskRes(void);
extern void PutSetEvt(uint8 task_no);
extern void PutClrEvt(uint8 task_no);
extern void PutGetEvt(uint8 task_no);
extern void PutWaitEvt(uint8 task_no);
extern void PutArmBase(void);
extern void PutArmTick(void);
extern void PutSetRel(uint8 alarm_no, uint8 tick_no, uint8 cycle_no);
extern void PutCanArm(void);
extern void PutAppMode(void);
extern void schedule_table_sample_routine(void);
extern void PutActNonPriTsk(void);
static void IocProk1(void);
static uint8 GetCommandNoWait1(void);


/*
 *  ؿץȥ
 */
TASK(NonPriTask);
TASK(Task6);
TASK(Task7);
TASK(IocTask3);
TASK(IocTask4);

DEFINE_VAR_SSTACK(StackType, stack_00[COUNT_STK_T(0x200)]);

/*
 *  API顼ޥ
 *
 *  ErrorHookͭξErrorHook
 *  顼Ϥ, ErrorHook̵ξ
 *  ʲΥޥꥨ顼ϤԤ
 */
#if defined(CFG_USE_ERRORHOOK)
#define error_log(api)	(api)
#define error_log_ioc(api)	(api)
#else /* !defined( CFG_USE_ERRORHOOK ) */
#define	error_log(api)										   \
	{														   \
		StatusType ercd;									   \
		ercd = api;     /* API¹ */						   \
		if (ercd != E_OK) {									   \
			syslog(LOG_INFO, "Error:%d", atk2_strerror(ercd)); \
		}													   \
	}

#define	error_log_ioc(api)										   \
	{															   \
		StatusType ercd;										   \
		ercd = api;     /* API¹ */							   \
		if (ercd != E_OK) {										   \
			syslog(LOG_INFO, "Error:%d", atk2_ioc_strerror(ercd)); \
		}														   \
	}
#endif /* defined( CFG_USE_ERRORHOOK ) */

/*
 *  ѥ᡼¤Τ
 *  ؿ󶡼Ԥإåե󶡤
 */

struct parameter_struct {
	sint32		*name1;
	sint32		name2;
	TaskType	task_no;
	StatusType	ercd;
	StatusType	return_value;   /* ͤϹ¤Τ˴ޤ */
};

/*
 *  ؿ
 */

TRUSTEDFUNCTION(TRUSTED_tfnt1, FunctionIndex, FunctionParams)
{
	struct parameter_struct *local = FunctionParams;

	sint32					*p1;
	sint32					p2;

	p1 = local->name1;
	p2 = local->name2;

	local->return_value = (StatusType) ((*p1 * 2) + p2);
	return(E_OK);
}

/*
 *  ؿtfnt2
 *    OSץꥱ󤫤Ϥ줿
 *    ݥ󥿰ɽơ׻̤
 *    OSץꥱ֤
 */
TRUSTEDFUNCTION(TRUSTED_tfnt2, FunctionIndex, FunctionParams)
{
	struct parameter_struct *local = FunctionParams;

	sint32					*p1;
	sint32					p2;

	p1 = local->name1;
	p2 = local->name2;

	local->return_value = (StatusType) ((*p1 * 4) + p2);
	return(E_OK);
}

/*
 *  ؿtfnt3
 *    OSץꥱ󤫤ShutdownAllCores
 *    դ
 */
TRUSTEDFUNCTION(TRUSTED_tfnt3, FunctionIndex, FunctionParams)
{
	struct parameter_struct *local = FunctionParams;

	StatusType				ercd;

	ercd = local->ercd;
	ShutdownAllCores(ercd);

	return(E_OK);
}

/*
 *  ؿtfnt4
 *    OSץꥱ󤫤鿮OSץ
 *    ˽°륿ư
 */
TRUSTEDFUNCTION(TRUSTED_tfnt4, FunctionIndex, FunctionParams)
{
	struct parameter_struct *local = FunctionParams;

	TaskType				task_no;

	task_no = local->task_no;

	error_log(ActivateTask(task_no));

	return(E_OK);
}

/*
 *  Υץꥨץƥ֥
 *
 *  ¹ϥץꥨץȤʤȤγǧ
 */
TASK(NonPriTask)
{
	syslog(LOG_INFO, "NonPriTask ACTIVATE");
	syslog(LOG_INFO, "Call ActivateTask(HighPriorityTask)");
	error_log(ActivateTask(HighPriorityTask));
	syslog(LOG_INFO, "NonPriTask TERMINATE");

	error_log(TerminateTask());
}   /* TASK( NonPriTask ) */

/*
 *  ¹ԥ6
 */
TASK(Task6)
{
	uint8 command;          /* ޥɼХåե */

	syslog(LOG_INFO, "Task6 ACTIVATE");

	command = '\0';
	do {
		WaitEvent(T6Evt);
		ClearEvent(T6Evt);
		RecvPolSerialChar(&command);
		if (command == '\n') {
			command = '\0';
		}
	} while (command == '\0');

	syslog(LOG_INFO, "Inputed char = '%c'", command);

	syslog(LOG_INFO, "Task6 TERMINATE");

	error_log(ChainTask(Task6));
}   /* TASK( Task6 ) */

/*
 *  ¹ԥ7
 */
TASK(Task7)
{
	syslog(LOG_INFO, "Task7");
	TerminateTask();
}   /* TASK( Task7 ) */


TASK(Task13)
{
	syslog(LOG_INFO, "Task13 ACTIVATE!!!");
	syslog(LOG_INFO, "Task13 -> ChainTask(Task14)!");
	ChainTask(Task14);
}

TASK(Task14)
{
	syslog(LOG_INFO, "Task14 ACTIVATE!!!");
	TerminateTask();
}

TASK(Task17)
{
	TryToGetSpinlockType	success = TRYTOGETSPINLOCK_NOSUCCESS;
	volatile sint32			j;

	syslog(LOG_INFO, "Task17 ACTIVATE");

	/* ԥåѿ */
	for (j = 0; j < 10000; j++) {
		lock_var1++;
	}

	/* ԥå */
	error_log(TryToGetSpinlock(SmpSpin, &success));
	while (success != TRYTOGETSPINLOCK_SUCCESS) {
		error_log(TryToGetSpinlock(SmpSpin, &success));
		syslog(LOG_INFO, "TryToGetSpinlock(SmpSpin, &success) success = %d wait...", success);
		/* ֤Υ */
		for (j = 0; j < 10000; j++) {
		}
	}

	/* ԥåơѿ */
	for (j = 0; j < 10000; j++) {
		lock_var2++;
	}
	/* ԥåʤޤlock_var1ѿ򥢥 */
	syslog(LOG_INFO, "(Task17)(1)global variable lock_var1 = %d", lock_var1);
	syslog(LOG_INFO, "(Task17)(2)global variable lock_var2 = %d", lock_var2);
	/* ԥå */
	error_log(ReleaseSpinlock(SmpSpin));

	syslog(LOG_INFO, "Task17 TERMINATE");
	TerminateTask();
}

/*
 *  IOCǧѥ3
 */
TASK(IocTask3)
{
	syslog(LOG_INFO, "IocTask3 ACTIVATE");

	IocProk1();

	syslog(LOG_INFO, "IocTask3 TERMINATE");
	error_log(SetEvent(MainTask, IocEvt));
	TerminateTask();
}   /* TASK( IocTask3 ) */

/*
 *  IOCǧѥ4
 */
TASK(IocTask4)
{
	syslog(LOG_INFO, "IocTask4 ACTIVATE");

	IocProk1();

	syslog(LOG_INFO, "IocTask4 TERMINATE");
	error_log(CallTrustedFunction(setiocevt2, NULL));
	TerminateTask();
}   /* TASK( IocTask4 ) */

/*
 *  ޥɼ(̵)
 */
uint8
GetCommandNoWait1(void)
{
	uint8 command;          /* ޥɼХåե */

	/*
	 *  ޥɤޤǥ롼
	 */
	command = '\0';
	do {
		RecvPolSerialChar(&command);    /* Хåեݡ */
		if (command == '\n') {
			command = '\0';
		}
	} while (command == '\0');

	return(command);
}   /* GetCommandNoWait1 */

/*
 *  IOCǧѥ(sample2)
 *
 */
static void
IocProk1(void)
{
	uint8			api;        /* ޥɼХåե(API) */
	uint8			data[3];    /* ̿Хåե */

	volatile sint32 i;
	Std_ReturnType	ercd;

	syslog(LOG_INFO, "Select IOC API:");
	api = GetCommandNoWait1();
#ifndef OMIT_ECHO
	syslog(LOG_INFO, "%c", api);
#endif /* OMIT_ECHO */

	switch (api) {
	case '1':
		syslog(LOG_INFO, "Input send data:");
		data[0] = GetCommandNoWait1();
#ifndef OMIT_ECHO
		syslog(LOG_INFO, "%c", data[0]);
#endif /* OMIT_ECHO */

		syslog(LOG_INFO, "Call IocSend_IOC_QUE_0");
		error_log_ioc(IocSend_IOC_QUE_0(data[0]));
		break;
	case '2':
		syslog(LOG_INFO, "Input send data:");
		data[0] = GetCommandNoWait1();
#ifndef OMIT_ECHO
		syslog(LOG_INFO, "%c", data[0]);
#endif /* OMIT_ECHO */

		syslog(LOG_INFO, "Call IocSend_IOC_QUE_1");
		error_log_ioc(IocSend_IOC_QUE_1(data[0]));
		break;
	case '3':
		for (i = 0; i < 3U; i++) {
			syslog(LOG_INFO, "Input send data%d:", i);
			data[i] = GetCommandNoWait1();
#ifndef OMIT_ECHO
			syslog(LOG_INFO, "%c", data[i]);
#endif /* OMIT_ECHO */
		}
		syslog(LOG_INFO, "Call IocWriteGroup_IOC_DEQUE");
		error_log_ioc(IocWriteGroup_IOC_DEQUE(data[0], data[1], data[2]));
		break;
	case '4':
		syslog(LOG_INFO, "Call IocReceive_IOC_QUE");
		ercd = IocReceive_IOC_QUE(&data[0]);
#if !defined(CFG_USE_ERRORHOOK)
		if (ercd != E_OK) {
			syslog(LOG_INFO, "Error:%d", atk2_ioc_strerror(ercd));
		}
#endif /* !defined( CFG_USE_ERRORHOOK ) */
		if ((ercd == IOC_E_OK) || (ercd == IOC_E_LOST_DATA)) {
			syslog(LOG_INFO, "recv data:%c", data[0]);
		}
		break;
	case '5':
		syslog(LOG_INFO, "Call IocReadGroup_IOC_DEQUE");
		error_log_ioc(IocReadGroup_IOC_DEQUE(&data[0], &data[1], &data[2]));
		for (i = 0; i < 3U; i++) {
			syslog(LOG_INFO, "recv data%d:%c", i, data[i]);
		}
		break;
	case '6':
		syslog(LOG_INFO, "Call IocEmptyQueue_IOC_QUE");
		error_log_ioc(IocEmptyQueue_IOC_QUE());
		break;
	default:
		syslog(LOG_INFO, "undefined command");
		break;
	}
}   /* IocProk1 */

TRUSTEDFUNCTION(TRUSTED_setiocevt2, FunctionIndex, FunctionParams)
{
	error_log(SetEvent(MainTask, IocEvt));

	return(E_OK);
}


void
StartupHook_NT_osap2(void)
{
	syslog(LOG_INFO, "");
	syslog(LOG_INFO, "Sample StartupHook_NT_osap2!!!");
}

void
ShutdownHook_NT_osap2(StatusType Error)
{
	syslog(LOG_INFO, "");
	syslog(LOG_INFO, "Sample ShutdownHook_NT_osap2!!!");
	syslog(LOG_INFO, "ShutDownCode:%s", atk2_strerror(Error));
}

void
ErrorHook_NT_osap2(StatusType Error)
{
	syslog(LOG_INFO, "");
	syslog(LOG_INFO, "Sample ErrorHook_NT_osap2!!!");
	syslog(LOG_INFO, "ErrorCode:%s", atk2_strerror(Error));
}
